package ip.e_biz;

import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.io.*;

public class Card implements Serializable {

    static final long serialVersionUID = 3161590552361087588L;

    private int id;
    private byte[] frontImage;
    private byte[] backImage;
    private String email;
    private String telephone;
    private String website;
    private boolean isShared;

    public Card(BufferedImage frontImage, BufferedImage backImage, String email, String telephone, String website) {

        setFrontImage(frontImage);
        setBackImage(backImage);
        this.email = email;
        this.telephone = telephone;
        this.website = website;
        this.isShared = false;

    }

    public void setBackImage(BufferedImage backImage) {

        try {

            ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
            ImageIO.write(backImage, "png", byteArrayOutputStream);

            this.backImage = byteArrayOutputStream.toByteArray();

        } catch (IOException e) {

            e.printStackTrace();

        }

    }

    public void setShared(boolean isShared) {

        this.isShared = isShared;

    }

    public boolean isShared() {

        return isShared;

    }

    public void setEmail(String email) {

        this.email = email;

    }

    public void setFrontImage(BufferedImage frontImage) {

        try {

            ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
            ImageIO.write(frontImage, "png", byteArrayOutputStream);

            this.frontImage = byteArrayOutputStream.toByteArray();

        } catch (IOException e) {

            e.printStackTrace();

        }

    }

    public void setID(int ID) {

        id = ID;

    }

    public void setTelephone(String telephone) {

        this.telephone = telephone;

    }

    public void setWebsite(String website) {

        this.website = website;

    }

    public BufferedImage getBackImage() {

        try {

            InputStream in = new ByteArrayInputStream(backImage);
            return ImageIO.read(in);

        } catch (IOException e) {

            e.printStackTrace();

        }

        return null;

    }

    public BufferedImage getFrontImage() {

        try {

            InputStream in = new ByteArrayInputStream(frontImage);
            return ImageIO.read(in);

        } catch (IOException e) {

            e.printStackTrace();

        }

        return null;

    }

    public String getEmail() {

        return email;

    }

    public int getID() {

        return id;

    }

    public String getTelephone() {

        return telephone;

    }

    public String getWebsite() {

        return website;

    }

}