package uk.ac.bath.oy213.ip.server.commands.net;

import ip.e_biz.Card;
import uk.ac.bath.oy213.ip.server.location.UserLocation;
import uk.ac.bath.oy213.ip.server.Server;
import uk.ac.bath.oy213.ip.server.net.ConnectionThread;
import uk.ac.bath.oy213.ip.server.net.Packet;
import uk.ac.bath.oy213.ip.server.util.CardBuilder;

import java.util.ArrayList;

/**
 * Created by Ollie on 14/04/15.
 */
public class GetLocalCardsCommand extends NetCommand {

    public GetLocalCardsCommand() {

        super("request-local-cards");

    }

    @Override
    public void dispatch(ConnectionThread connection, String[] args, Object data) {

        dispatch(connection,args);

    }

    @Override
    public void dispatch(ConnectionThread connection, String[] args) {

        if (args.length != 3) {

            connection.sendPacket(new Packet(null,"error",null,null));

        } else {

            ArrayList<Card> cards = new ArrayList<>();

            for (String user: Server.instance().getLocationTable().getUsersWithinRadius(new UserLocation(connection.getUsername(),Double.parseDouble(args[0]),Double.parseDouble(args[1])), Double.parseDouble(args[2]))) {

                for (Card c: CardBuilder.getSharedCardsFromUser(user)) {

                    cards.add(c);

                }

            }

            if (cards.isEmpty()) {

                connection.sendPacket(new Packet(null,"no-cards-found",null,null));

            } else {

                connection.sendPacket(new Packet(null,"cards-found",null,cards));

            }

        }

    }

}
