package uk.ac.bath.oy213.ip.server.commands.net;

import uk.ac.bath.oy213.ip.server.Server;
import uk.ac.bath.oy213.ip.server.net.ConnectionThread;
import uk.ac.bath.oy213.ip.server.net.Packet;
import uk.ac.bath.oy213.ip.server.util.CardBuilder;
import uk.ac.bath.oy213.ip.server.util.LoggingLevel;

import java.sql.ResultSet;
import java.sql.SQLException;

/**
 * Created by Ollie on 14/04/15.
 */
public class RequestCardCommand extends NetCommand {

    public RequestCardCommand() {

        super("request-card");

    }

    @Override
    public void dispatch(ConnectionThread connection, String[] args, Object data) {

        dispatch(connection, args);

    }

    @Override
    public void dispatch(ConnectionThread connection, String[] args) {

        if (args.length != 1) {

            connection.sendPacket(new Packet(null,"error",null,null));

        } else {

            int cardID = Integer.parseInt(args[0]);

            ResultSet resultSet = Server.instance().getDatabaseConnection().callStoredProcedure("getCard",cardID);

            try {

                if (!resultSet.next()) {

                    connection.sendPacket(new Packet(null, "request-failed", new String[]{"card not found"}, null));

                } else {

                    connection.sendPacket(new Packet(null,"card-found",null,CardBuilder.buildCard(resultSet)));

                }

            } catch (SQLException | NumberFormatException e) {

                Server.instance().log(LoggingLevel.SEVERE, e.getMessage());

                connection.sendPacket(new Packet(null,"error",null,null));

            }

        }

    }

}
