package uk.ac.bath.oy213.ip.server.commands.net;

import ip.e_biz.Card;
import uk.ac.bath.oy213.ip.server.Server;
import uk.ac.bath.oy213.ip.server.net.ConnectionThread;
import uk.ac.bath.oy213.ip.server.net.Packet;
import uk.ac.bath.oy213.ip.server.util.CardBuilder;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

/**
 * Created by Ollie on 15/04/15.
 */
public class RequestSavedCardsCommand extends NetCommand {

    public RequestSavedCardsCommand() {

        super("request-saved-cards");

    }

    @Override
    public void dispatch(ConnectionThread connection, String[] args, Object data) {

        dispatch(connection,args);

    }

    @Override
    public void dispatch(ConnectionThread connection, String[] args) {

        ResultSet resultSet = Server.instance().getDatabaseConnection().callStoredProcedure("getUsersSavedCards",connection.getUsername());

        try {

            if (!resultSet.next()) {

                connection.sendPacket(new Packet(null, "no-cards-found", null, null));

            } else {

                ArrayList<Card> cards = new ArrayList<>();

                do {

                    cards.add(CardBuilder.buildCard(resultSet));

                } while (resultSet.next());

                connection.sendPacket(new Packet(null,"cards-found",null,cards));

            }

        } catch (SQLException e) {

            connection.sendPacket(new Packet(null,"error",null,null));

        }

    }

}
