package uk.ac.bath.oy213.ip.server.commands.net;

import uk.ac.bath.oy213.ip.server.Server;
import uk.ac.bath.oy213.ip.server.net.ConnectionThread;
import uk.ac.bath.oy213.ip.server.net.Packet;
import uk.ac.bath.oy213.ip.server.util.CardBuilder;
import uk.ac.bath.oy213.ip.server.util.LoggingLevel;

import java.sql.ResultSet;
import java.sql.SQLException;

/**
 * Created by Ollie on 20/04/15.
 */
public class RequestUsersMasterCardCommand extends NetCommand {

    public RequestUsersMasterCardCommand() {

        super("request-master-card");

    }

    @Override
    public void dispatch(ConnectionThread connection, String[] args, Object data) {

        dispatch(connection,args);

    }

    @Override
    public void dispatch(ConnectionThread connection, String[] args) {

        ResultSet resultSet = Server.instance().getDatabaseConnection().callStoredProcedure("getUsersMasterCard",connection.getUsername());

        try {

            if (!resultSet.next()) {

                connection.sendPacket(new Packet(null, "card-not-found", null, null));

            } else {

                connection.sendPacket(new Packet(null, "card-found", null, CardBuilder.buildCard(resultSet)));

            }

        } catch (SQLException e) {

            connection.sendPacket(new Packet(null, "error", null, null));

        }

    }

}
