package uk.ac.bath.oy213.ip.server.commands.net;

import ip.e_biz.Card;
import uk.ac.bath.oy213.ip.server.Server;
import uk.ac.bath.oy213.ip.server.net.ConnectionThread;
import uk.ac.bath.oy213.ip.server.net.Packet;
import uk.ac.bath.oy213.ip.server.util.FileHandler;

/**
 * Created by Ollie on 14/04/15.
 */
public class SaveCardCommand extends NetCommand {

    public SaveCardCommand() {

        super("save-card");

    }

    @Override
    public void dispatch(ConnectionThread connection, String[] args, Object data) {

       dispatch(connection, args);

    }

    @Override
    public void dispatch(ConnectionThread connection, String[] args) {

        if (args.length != 1) {

            connection.sendPacket(new Packet(null,"error",null,null));

        } else {

            try {

                int cardID = Integer.parseInt(args[0]);

                Server.instance().getDatabaseConnection().callStoredProcedure("saveCard", connection.getUsername(), cardID);

                connection.sendPacket(new Packet(null,"save-success",null,null));

            } catch (NumberFormatException e) {

                connection.sendPacket(new Packet(null,"error",null,null));

            }

        }

    }

}
