package uk.ac.bath.oy213.ip.server.commands.net;

import ip.e_biz.Card;
import uk.ac.bath.oy213.ip.server.Server;
import uk.ac.bath.oy213.ip.server.net.ConnectionThread;
import uk.ac.bath.oy213.ip.server.net.Packet;
import uk.ac.bath.oy213.ip.server.util.FileHandler;
import uk.ac.bath.oy213.ip.server.util.LoggingLevel;

import java.sql.ResultSet;
import java.sql.SQLException;

/**
 * Created by Ollie on 20/04/15.
 */
public class SetMasterCardCommand extends NetCommand {

    public SetMasterCardCommand() {

        super("set-master-card");

    }

    @Override
    public void dispatch(ConnectionThread connection, String[] args, Object data) {

        try {

            Card card = (Card) data;

            int cardID = card.getID();

            ResultSet resultSet = Server.instance().getDatabaseConnection().callStoredProcedure("getUsersMasterCard", connection.getUsername());

            if (resultSet.next()) {

                Server.instance().getDatabaseConnection().callStoredProcedure("setNotMaster", resultSet.getInt("cardID"));

            }

            Server.instance().getDatabaseConnection().callStoredProcedure("setMaster", cardID);

            connection.sendPacket(new Packet(null, "master-success", null, null));

        } catch (SQLException | NumberFormatException | ClassCastException e) {

            connection.sendPacket(new Packet(null,"error",null,null));

        } catch (NullPointerException e) {

            try {

                Card card = (Card) data;

                String[] paths = FileHandler.generateImagePaths(connection.getUsername());

                Server.instance().getDatabaseConnection().callStoredProcedure("saveCard",connection.getUsername(),paths[0],paths[1],card.getEmail(),card.getTelephone(),card.getWebsite(),true,true);

                FileHandler.writeImage(card.getFrontImage(), paths[0]);
                FileHandler.writeImage(card.getBackImage(), paths[1]);

                connection.sendPacket(new Packet(null,"master-success",null,null));

            } catch (ClassCastException | IndexOutOfBoundsException e1) {

                connection.sendPacket(new Packet(null,"error",null,null));

            }

        }

    }

    @Override
    public void dispatch(ConnectionThread connection, String[] args) {



    }

}
