package uk.ac.bath.oy213.ip.server.commands.net;

import uk.ac.bath.oy213.ip.server.Server;
import uk.ac.bath.oy213.ip.server.net.ConnectionThread;
import uk.ac.bath.oy213.ip.server.net.Packet;
import uk.ac.bath.oy213.ip.server.util.LoggingLevel;

import java.sql.ResultSet;
import java.sql.SQLException;

/**
 * Created by Ollie on 14/04/15.
 */
public class ShareCardCommand extends NetCommand {

    public ShareCardCommand() {

        super("share-card");

    }

    @Override
    public void dispatch(ConnectionThread connection, String[] args, Object data) {

        dispatch(connection,args);

    }

    @Override
    public void dispatch(ConnectionThread connection, String[] args) {

        if (args.length != 1) {

            connection.sendPacket(new Packet(null,"error",null,null));

        } else {

            ResultSet resultSet = Server.instance().getDatabaseConnection().callStoredProcedure("getUsersOwnCards", connection.getUsername());

            try {

                if (!resultSet.next()) {

                    connection.sendPacket(new Packet(null, "error", null, null));

                } else {

                    boolean isUsersCard = false;
                    int cardID = Integer.parseInt(args[0]);

                    do {

                        if (cardID == resultSet.getInt("CardID")) {

                            isUsersCard = true;
                            break;

                        }

                    } while (resultSet.next());

                    if (isUsersCard) {

                        Server.instance().getDatabaseConnection().callStoredProcedure("setShared",cardID);
                        connection.sendPacket(new Packet(null,"share-success",null,null));

                    } else {

                        connection.sendPacket(new Packet(null, "error", null, null));

                    }

                }

            } catch (SQLException | NumberFormatException e) {

                Server.instance().log(LoggingLevel.SEVERE,e.getMessage());
                connection.sendPacket(new Packet(null, "error", null, null));

            }

        }

    }

}
