package uk.ac.bath.oy213.ip.server.commands.net;

import uk.ac.bath.oy213.ip.server.location.UserLocation;
import uk.ac.bath.oy213.ip.server.Server;
import uk.ac.bath.oy213.ip.server.net.ConnectionThread;
import uk.ac.bath.oy213.ip.server.net.Packet;
import uk.ac.bath.oy213.ip.server.util.CardBuilder;

import java.util.ArrayList;

/**
 * Created by Ollie on 16/04/15.
 */
public class UpdateLocationCommand extends NetCommand {

    public UpdateLocationCommand() {

        super("update-location");

    }

    @Override
    public void dispatch(ConnectionThread connection, String[] args, Object data) {

        dispatch(connection,args);

    }

    @Override
    public void dispatch(ConnectionThread connection, String[] args) {

        if (args.length != 3) {

            connection.sendPacket(new Packet(null,"error",null,null));

        } else {

            Server.instance().getLocationTable().updateLocation(new UserLocation(connection.getUsername(),Double.parseDouble(args[0]),Double.parseDouble(args[1])));

            ArrayList<Integer> cardsIDList = new ArrayList<>();

            for (String user: Server.instance().getLocationTable().getUsersWithinRadius(new UserLocation(connection.getUsername(),Double.parseDouble(args[0]),Double.parseDouble(args[1])), Double.parseDouble(args[2])/1000.0)) {

                for (Integer i : CardBuilder.getSharedCardIDsFromUser(user)) {

                    cardsIDList.add(i);

                }

            }

            connection.sendPacket(new Packet(null,"push-new-cards",null,cardsIDList));

        }

    }

}
