package uk.ac.bath.oy213.ip.server.commands.net;

import ip.e_biz.Card;
import uk.ac.bath.oy213.ip.server.Server;
import uk.ac.bath.oy213.ip.server.net.ConnectionThread;
import uk.ac.bath.oy213.ip.server.net.Packet;
import uk.ac.bath.oy213.ip.server.util.FileHandler;

/**
 * Created by Ollie on 19/04/15.
 */
public class UploadCardCommand extends NetCommand {

    public UploadCardCommand() {

        super("upload-card");

    }

    @Override
    public void dispatch(ConnectionThread connection, String[] args, Object data) {

        try {

            Card card = (Card) data;

            String[] paths = FileHandler.generateImagePaths(connection.getUsername());

            FileHandler.writeImage(card.getFrontImage(), paths[0]);
            FileHandler.writeImage(card.getBackImage(), paths[1]);

            Server.instance().getDatabaseConnection().callStoredProcedure("uploadCard", connection.getUsername(), paths[0], paths[1], card.getEmail(), card.getTelephone(), card.getWebsite(), false, false);

            connection.sendPacket(new Packet(null,"upload-success",null,null));

        } catch (ClassCastException | IndexOutOfBoundsException e) {

            connection.sendPacket(new Packet(null,"error",null,null));

        }

    }

    @Override
    public void dispatch(ConnectionThread connection, String[] args) {

        connection.sendPacket(new Packet(null,"error",null,null));

    }

}
