package uk.ac.bath.oy213.ip.server.commands.user;

import uk.ac.bath.oy213.ip.server.Server;
import uk.ac.bath.oy213.ip.server.security.AuthenticationToken;
import uk.ac.bath.oy213.ip.server.util.Colour;
import uk.ac.bath.oy213.ip.server.util.LoggingLevel;

import java.io.PrintStream;

/**
 * Created by Ollie on 14/04/15.
 */
public class ListAuthTableCommand extends UserCommand {

    public ListAuthTableCommand() {

        super("lt");

        addAlias("listtok");
        addAlias("listtokens");
        
    }

    @Override
    public void dispatch(String[] args) {

        Server.instance().log(LoggingLevel.SERVER, "listing all currently leased tokens:");

        PrintStream out = LoggingLevel.SERVER.getStream();

        out.printf(Colour.ANSI_BLUE + "%n%-8s %-36s %-7s%n" + Colour.ANSI_GREEN, "Username", "Token", "Expired");
        out.printf("%-8s %-36s %-7s%n" + LoggingLevel.SERVER.getReset(), "--------", "------------------------------------", "-------");

        for (AuthenticationToken t: Server.instance().getTokenRegistry().getTokens()) {

            if (t.getExpirationTime() > System.currentTimeMillis()) {

                out.printf("%-8s %-36s %-7s%n" + LoggingLevel.SERVER.getReset(), Server.instance().getTokenRegistry().getUsername(t), t.getId(), Colour.ANSI_GREEN+"No"+LoggingLevel.SERVER.getReset());

            } else {

                out.printf("%-8s %-36s %-7s%n" + LoggingLevel.SERVER.getReset(), Server.instance().getTokenRegistry().getUsername(t), t.getId(), Colour.ANSI_RED+"Yes"+LoggingLevel.SERVER.getReset());

            }

        }

    }

    @Override
    public String[] showHelp(boolean isVerbose) {

        return new String[] {"lists all of the currently leased authentication tokens."};

    }

}
