package uk.ac.bath.oy213.ip.server.commands.user;

import uk.ac.bath.oy213.ip.server.Server;
import uk.ac.bath.oy213.ip.server.net.ConnectionThread;
import uk.ac.bath.oy213.ip.server.util.Colour;
import uk.ac.bath.oy213.ip.server.util.LoggingLevel;

import java.io.OutputStream;
import java.io.PrintStream;

/**
 * Created by Ollie on 14/04/15.
 */
public class ListConnectionsCommand extends UserCommand {

    public ListConnectionsCommand() {

        super("lc");

        addAlias("listconn");
        addAlias("listconnections");

    }

    @Override
    public void dispatch(String[] args) {

        Server.instance().log(LoggingLevel.SERVER, "listing all current connections:");

        PrintStream out = LoggingLevel.SERVER.getStream();

        out.printf(Colour.ANSI_BLUE + "%n%-10s %-30s%n" + Colour.ANSI_GREEN, "ID", "Address");
        out.printf("%-10s %-30s%n" + LoggingLevel.SERVER.getReset(), "----------", "-------------");

        for (ConnectionThread c: Server.instance().getListenerThread().getConnections()) {

            out.printf("%-10d %-30s%n", c.getConnectionID(), c.getAddress());

        }

    }

    @Override
    public String[] showHelp(boolean isVerbose) {

        return new String[] {"lists all currently connected clients."};

    }

}
