package uk.ac.bath.oy213.ip.server.commands.user;

import uk.ac.bath.oy213.ip.server.Server;
import uk.ac.bath.oy213.ip.server.net.ConnectionThread;
import uk.ac.bath.oy213.ip.server.net.Packet;
import uk.ac.bath.oy213.ip.server.util.Colour;
import uk.ac.bath.oy213.ip.server.util.LoggingLevel;

/**
 * Created by Ollie on 26/04/15.
 */
public class SendPacketCommand extends UserCommand {

    public SendPacketCommand() {

        super("send");

    }

    @Override
    public void dispatch(String[] args) {

        if (args.length < 2) {

            Server.instance().log(LoggingLevel.WARNING, "Invalid number of arguments, type '" + Colour.ANSI_GREEN + "help send" + LoggingLevel.WARNING.getReset() + "' for more information.");

        } else {

            try {

                int connectionID = Integer.parseInt(args[1]);

                for (ConnectionThread connection: Server.instance().getListenerThread().getConnections()) {

                    if (connection.getConnectionID() == connectionID) {

                        connection.sendPacket(new Packet(null, args[0], null, null));
                        Server.instance().log(LoggingLevel.SERVER, "Command '"+Colour.ANSI_GREEN+args[0]+LoggingLevel.SERVER.getReset()+"' sent to client "+Colour.ANSI_GREEN+connectionID+LoggingLevel.SERVER.getReset()+".");
                        return;

                    }

                }

                Server.instance().log(LoggingLevel.WARNING, "No client connection with ID:" + Colour.ANSI_GREEN + connectionID + LoggingLevel.WARNING.getReset() + ".");

            } catch (NumberFormatException e) {

                Server.instance().log(LoggingLevel.WARNING, "Invalid connection ID, type '" + Colour.ANSI_GREEN + "help send" + LoggingLevel.WARNING.getReset() + "' for more information.");

            }

        }

    }

    @Override
    public String[] showHelp(boolean isVerbose) {

        if (isVerbose) {

            return new String[] {"sends a packet with the given string message to the given client.","send <command> <connection ID>"};

        } else {

            return new String[] {"sends the given command to the given client."};

        }

    }

}
