package uk.ac.bath.oy213.ip.server.commands.user;

import uk.ac.bath.oy213.ip.server.Server;
import uk.ac.bath.oy213.ip.server.net.ConnectionThread;
import uk.ac.bath.oy213.ip.server.util.Colour;
import uk.ac.bath.oy213.ip.server.util.LoggingLevel;

/**
 * Created by Ollie on 14/04/15.
 */
public class TerminateConnectionCommand extends UserCommand {

    public TerminateConnectionCommand() {

        super("term");

        addAlias("t");
        addAlias("terminate");

    }

    @Override
    public void dispatch(String[] args) {

        if (args.length != 1) {

            Server.instance().log(LoggingLevel.WARNING, "Invalid number of arguments, type '" + Colour.ANSI_GREEN + "help term" + LoggingLevel.WARNING.getReset() + "' for more information.");

        } else {

            try {

                int ID = Integer.parseInt(args[0]);

                for (ConnectionThread c: Server.instance().getListenerThread().getConnections()) {

                    if (c.getConnectionID() == ID) {

                        c.interrupt();
                        Server.instance().log(LoggingLevel.SERVER, "Connection: "+Colour.ANSI_GREEN+c.getAddress()+LoggingLevel.SERVER.getReset()+" terminated.");
                        return;

                    }

                }

                Server.instance().log(LoggingLevel.WARNING, "No connection found with ID '"+Colour.ANSI_GREEN+ID+LoggingLevel.WARNING.getReset()+"'.");

            } catch (NumberFormatException e) {

                Server.instance().log(LoggingLevel.WARNING, "Invalid connection ID format '" + Colour.ANSI_GREEN + args[0] + LoggingLevel.WARNING.getReset() + "'.");

            }

        }

    }

    @Override
    public String[] showHelp(boolean isVerbose) {

        return isVerbose ? new String[] {"terminates a currently active network connection.", "term <connection-id>"} : new String[] {"terminates a currently active connection"};

    }

}
