package uk.ac.bath.oy213.ip.server.net;

import ip.e_biz.Card;
import uk.ac.bath.oy213.ip.server.Server;
import uk.ac.bath.oy213.ip.server.util.LoggingLevel;

import java.io.Serializable;
import java.util.UUID;

/**
 * Created by Ollie on 28/03/15.
 */
public class Packet implements Serializable {

    private String command;
    private Object data;
    private String[] args;
    private final UUID authToken;

    public Packet(UUID authToken, String command, String[] args, Object data) {

        this.authToken = authToken;
        this.command = command;
        this.data = data;
        this.args = args;

    }

    public String getCommand() {

        return command;

    }

    public Object getData() {

        return data;

    }

    public String[] getArgs() {

        return args;

    }

    public UUID getAuthToken() {

        return authToken;

    }

    public static Object[] compress(Packet packet) {

        Object[] serialised = new Object[4];

        if (packet.getAuthToken() != null) {

            serialised[0] = packet.getAuthToken();

        }

        if (packet.getCommand() != null) {

            serialised[1] = packet.getCommand();

        }

        if (packet.getArgs() != null) {

            serialised[2] = packet.getArgs();

        }

        if (packet.getData() != null) {

            serialised[3] = packet.getData();

        }

        return serialised;

    }

    public static Packet uncompress(Object streamData) {

        try {

            UUID authToken = null;
            String command = "";
            String[] args = new String[0];
            Object data = null;

            Object[] serialised = (Object[]) streamData;

            if (serialised[0] != null) {

                authToken = (UUID) serialised[0];

            }

            if (serialised[1] != null) {

                command = (String) serialised[1];

            }

            if (serialised[2] != null) {

                args = (String[]) serialised[2];

            }

            if (serialised[3] != null) {

                data = serialised[3];

            }

            return new Packet(authToken,command,args,data);

        } catch (ClassCastException | IndexOutOfBoundsException e) {

            Server.instance().log(LoggingLevel.SEVERE, e.getMessage());

            return new Packet(null,"error",null,null);

        }

    }

}
