package uk.ac.bath.oy213.ip.server.net;

import uk.ac.bath.oy213.ip.server.Server;
import uk.ac.bath.oy213.ip.server.util.LoggingLevel;

import javax.net.ssl.SSLServerSocket;
import javax.net.ssl.SSLServerSocketFactory;
import javax.net.ssl.SSLSocket;
import java.io.IOException;
import java.net.ServerSocket;
import java.util.ArrayList;

/**
 * Created by Ollie on 28/03/15.
 */
public class ServerListenerThread extends Thread {

    private ServerSocket serverSocket;
    private ArrayList<ConnectionThread> connections;
    private int port;
    private int connectionCount = 0;

    public ServerListenerThread(int port) {

        connections = new ArrayList<>();

        this.port = port;

    }

    @Override
    public void run() {

        //SSLServerSocketFactory socketFactory = (SSLServerSocketFactory) SSLServerSocketFactory.getDefault();

        try {

            //serverSocket = (SSLServerSocket) socketFactory.createServerSocket(port);
            serverSocket = new ServerSocket(port);

        } catch (IOException e) {

            Server.instance().log(LoggingLevel.SEVERE, "failed to bind port: " + port);
            Server.instance().log(LoggingLevel.SEVERE, "is a server already running?\n");
            Server.instance().log(LoggingLevel.SERVER, "Aborting startup.\n");
            System.exit(0);

        }

        while (!serverSocket.isClosed()) {

            try {

                ConnectionThread thread = new ConnectionThread(serverSocket.accept(), connectionCount++);

                connections.add(thread);

                thread.start();

            } catch (IOException e) {

                //swallow - server stopping

            }

        }

    }

    public void shutDown() {

        for (ConnectionThread c: connections) {

            c.interrupt();

        }

        try {

            serverSocket.close();

        } catch (IOException e) {

            Server.instance().log(LoggingLevel.SEVERE, e.getMessage());

        }

    }

    public ArrayList<ConnectionThread> getConnections() {

        return connections;

    }

    public void removeThread(ConnectionThread thread) {

        connections.remove(thread);

    }

}
