package uk.ac.bath.oy213.ip.server.util;

import com.mysql.jdbc.jdbc2.optional.MysqlDataSource;
import uk.ac.bath.oy213.ip.server.Server;

import java.sql.*;

/**
 * Created by Ollie on 13/04/15.
 */
public class DatabaseConnection {

    private Connection connection;

    private final String DATABASE_NAME = "EBIZ";

    public DatabaseConnection(String connectionURL) {

        try {

            MysqlDataSource dataSource = new MysqlDataSource();
            dataSource.setUser("root");
            dataSource.setPassword("swiftcard");
            dataSource.setServerName(connectionURL);

            connection = dataSource.getConnection();

            String useDB = "USE "+DATABASE_NAME;
            Statement statement = connection.createStatement();
            statement.execute(useDB);
            statement.close();

        } catch (SQLException e) {

            Server.instance().log(LoggingLevel.SEVERE, "Cannot connect to database!");
            Server.instance().log(LoggingLevel.SERVER, "Aborting startup.\n");

            System.exit(0);

        }

    }

    public ResultSet callStoredProcedure(String procedureName, String arg1) {

        try {

            PreparedStatement preparedStatement = connection.prepareStatement("{call " + DATABASE_NAME + "." + procedureName + "(?)}");
            preparedStatement.setString(1, arg1);
            preparedStatement.execute();
            ResultSet resultSet = preparedStatement.getResultSet();
            //preparedStatement.close();

            Server.instance().log(LoggingLevel.INFO, "SQL procedure "+procedureName+" called.");

            return resultSet;

        } catch (SQLException e) {

            Server.instance().log(LoggingLevel.SEVERE, e.getMessage());

        }

        return null;

    }

    public ResultSet callStoredProcedure(String procedureName, int arg1) {

        try {

            PreparedStatement preparedStatement = connection.prepareStatement("{call "+DATABASE_NAME+"." + procedureName + "(?)}");
            preparedStatement.setInt(1, arg1);
            preparedStatement.execute();
            ResultSet resultSet = preparedStatement.getResultSet();
            //preparedStatement.close();

            Server.instance().log(LoggingLevel.INFO, "SQL procedure " + procedureName + " called.");

            return resultSet;

        } catch (SQLException e) {

            Server.instance().log(LoggingLevel.SEVERE, e.getMessage());

        }

        return null;

    }

    public ResultSet callStoredProcedure(String procedureName, String arg1, String arg2) {

        try {

            PreparedStatement preparedStatement = connection.prepareStatement("{call "+DATABASE_NAME+"." + procedureName +"(?, ?)}");
            preparedStatement.setString(1, arg1);
            preparedStatement.setString(2, arg2);
            preparedStatement.execute();
            ResultSet resultSet = preparedStatement.getResultSet();
            //preparedStatement.close();

            Server.instance().log(LoggingLevel.INFO, "SQL procedure " + procedureName + " called.");

            return resultSet;

        } catch (SQLException e) {

            Server.instance().log(LoggingLevel.SEVERE, e.getMessage());

        }

        return null;

    }

    public ResultSet callStoredProcedure(String procedureName, String arg1, int arg2) {

        try {

            PreparedStatement preparedStatement = connection.prepareStatement("{call "+DATABASE_NAME+"." + procedureName +"(?, ?)}");
            preparedStatement.setString(1, arg1);
            preparedStatement.setInt(2, arg2);
            preparedStatement.execute();
            ResultSet resultSet = preparedStatement.getResultSet();
            //preparedStatement.close();

            Server.instance().log(LoggingLevel.INFO, "SQL procedure " + procedureName + " called.");

            return resultSet;

        } catch (SQLException e) {

            Server.instance().log(LoggingLevel.SEVERE, e.getMessage());

        }

        return null;

    }

    public ResultSet callStoredProcedure(String procedureName, String arg1, String arg3, String arg4, String arg5, String arg6, String arg7, boolean arg8, boolean arg9) {

        try {

            PreparedStatement preparedStatement = connection.prepareStatement("{call "+DATABASE_NAME+"." + procedureName +"(?, ?, ?, ?, ?, ?, ?, ?)}");
            preparedStatement.setString(1, arg1);
            preparedStatement.setString(2, arg3);
            preparedStatement.setString(3, arg4);
            preparedStatement.setString(4, arg5);
            preparedStatement.setString(5, arg6);
            preparedStatement.setString(6, arg7);
            preparedStatement.setBoolean(7, arg8);
            preparedStatement.setBoolean(8, arg9);
            preparedStatement.execute();
            ResultSet resultSet = preparedStatement.getResultSet();
            //preparedStatement.close();

            Server.instance().log(LoggingLevel.INFO, "SQL procedure " + procedureName + " called.");

            return resultSet;

        } catch (SQLException e) {

            Server.instance().log(LoggingLevel.SEVERE, e.getMessage());

        }

        return null;

    }

    public ResultSet callStoredProcedure(String procedureName, int arg1, String arg3, String arg4, String arg5, String arg6, String arg7, boolean arg8, boolean arg9) {

        try {

            PreparedStatement preparedStatement = connection.prepareStatement("{call "+DATABASE_NAME+"." + procedureName +"(?, ?, ?, ?, ?, ?, ?, ?)}");
            preparedStatement.setInt(1, arg1);
            preparedStatement.setString(2, arg3);
            preparedStatement.setString(3, arg4);
            preparedStatement.setString(4, arg5);
            preparedStatement.setString(5, arg6);
            preparedStatement.setString(6, arg7);
            preparedStatement.setBoolean(7, arg8);
            preparedStatement.setBoolean(8, arg9);
            preparedStatement.execute();
            ResultSet resultSet = preparedStatement.getResultSet();
            //preparedStatement.close();

            Server.instance().log(LoggingLevel.INFO, "SQL procedure " + procedureName + " called.");

            return resultSet;

        } catch (SQLException e) {

            Server.instance().log(LoggingLevel.SEVERE, e.getMessage());

        }

        return null;

    }

}
