package uk.ac.bath.oy213.ip.server.util;

import uk.ac.bath.oy213.ip.server.Server;

import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.io.File;

/**
 * Created by Ollie on 19/04/15.
 */
public class FileHandler {

    private static final String baseDir = System.getProperty("user.home")+File.separator+"EBIZ";

    public static String[] generateImagePaths(String username) {

        String[] paths = new String[2];

        File userDir = new File(baseDir+File.separator+username+File.separator);

        if (!userDir.exists()) {

            userDir.mkdirs();

        }

        int fileNo = (userDir.listFiles().length/2)+1;

        paths[0] = baseDir+File.separator+username+File.separator+fileNo+"front.png";
        paths[1] = baseDir+File.separator+username+File.separator+fileNo+"back.png";

        return paths;

    }

    public static void writeImage(BufferedImage image, String path) {

        File out = null;

        try {

            out = new File(path);
            ImageIO.write(image,"png",out);

        } catch (Exception e) {

            Server.instance().log(LoggingLevel.SEVERE, e.getMessage());

        }

    }

}
